var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  RsLibConfig: () => RsLibConfig,
  RspackPluginInstance: () => import_core.RspackPluginInstance,
  configName: () => configName,
  defineConfig: () => defineConfig,
  rslibPackages: () => rslibPackages,
  runBuilds: () => runBuilds,
  runCli: () => runCli,
  usePreEsModuleConfig: () => usePreEsModuleConfig
});
module.exports = __toCommonJS(src_exports);

// src/core/config.ts
var import_cli = require("@rspack/cli");
var import_core = require("@rspack/core");
var import_merge = __toESM(require("lodash/merge"));
var import_path = __toESM(require("path"));
function defineConfig(config) {
  var _a, _b;
  return {
    rspack: (0, import_cli.defineConfig)(config.rspack),
    lib: (_a = config == null ? void 0 : config.lib) == null ? void 0 : _a.map((conf) => (0, import_cli.defineConfig)((0, import_merge.default)({}, config.rspack, conf))),
    plugins: (_b = config.plugins) != null ? _b : []
  };
}
var RsLibConfig = class {
  constructor() {
  }
  static resolve(name) {
    return require(import_path.default.resolve(process.cwd(), name));
  }
};
function usePreEsModuleConfig(options) {
  return (0, import_merge.default)({
    output: {
      module: true,
      filename: "esm/index.js",
      chunkFormat: "module",
      library: {
        type: "module"
      }
    },
    optimization: {
      concatenateModules: true
    },
    experiments: {
      outputModule: true
    }
  }, options);
}

// src/core/run.ts
var import_core2 = require("@rspack/core");
var import_node_logger_plus = require("node-logger-plus");
var import_commander = require("commander");
function rslibPackages() {
  try {
    const config = import_commander.program.getOptionValue("config");
    runBuilds(RsLibConfig.resolve(config));
  } catch (err) {
    import_node_logger_plus.logger.error(err.message.split("\n")[0]);
  }
}
function runBuilds(libConfig, callback) {
  var _a, _b;
  const libLen = (_b = (_a = libConfig == null ? void 0 : libConfig.lib) == null ? void 0 : _a.length) != null ? _b : 0;
  if (!libLen && !libConfig.rspack) {
    import_node_logger_plus.logger.info(`lib length ${libLen}`, "build closed");
    return;
  }
  if (!libLen) {
    return (0, import_core2.rspack)(libConfig.rspack, (err, stats) => {
      callback == null ? void 0 : callback(err, stats, -1);
      const error = err || (stats == null ? void 0 : stats.hasErrors());
      if (error) {
        import_node_logger_plus.logger.error(error);
      }
      import_node_logger_plus.logger.success("Successify!");
    });
  }
  libConfig.lib.forEach((conf, index) => {
    var _a2, _b2;
    const name = (_b2 = (_a2 = conf == null ? void 0 : conf.output) == null ? void 0 : _a2.filename) != null ? _b2 : "library";
    try {
      return (0, import_core2.rspack)(conf, (err, stats) => {
        callback == null ? void 0 : callback(err, stats, index);
        const error = err || (stats == null ? void 0 : stats.hasErrors());
        if (error) {
          throw error;
        }
        import_node_logger_plus.logger.success(`[${name}] index: ${index} Successify!`);
      });
    } catch (err) {
      import_node_logger_plus.logger.error(`[${name}] index: ${index} ` + err.message.split("\n")[0]);
    }
  });
}

// src/const/config.ts
var configName = "rspack.lib.config.js";

// src/cli/index.ts
var import_commander2 = require("commander");
import_commander2.program.option("c, --config <config>", "配置文件路径", configName).action(() => {
  rslibPackages();
});
function runCli() {
  import_commander2.program.parse(process.argv);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  RsLibConfig,
  RspackPluginInstance,
  configName,
  defineConfig,
  rslibPackages,
  runBuilds,
  runCli,
  usePreEsModuleConfig
});
