var __require = /* @__PURE__ */ ((x) => typeof require !== "undefined" ? require : typeof Proxy !== "undefined" ? new Proxy(x, {
  get: (a, b) => (typeof require !== "undefined" ? require : a)[b]
}) : x)(function(x) {
  if (typeof require !== "undefined")
    return require.apply(this, arguments);
  throw Error('Dynamic require of "' + x + '" is not supported');
});

// src/core/config.ts
import { defineConfig as rsDefineConfig } from "@rspack/cli";
import { RspackPluginInstance } from "@rspack/core";
import merge from "lodash/merge";
import path from "path";
function defineConfig(config) {
  var _a, _b;
  return {
    rspack: rsDefineConfig(config.rspack),
    lib: (_a = config == null ? void 0 : config.lib) == null ? void 0 : _a.map((conf) => rsDefineConfig(merge({}, config.rspack, conf))),
    plugins: (_b = config.plugins) != null ? _b : []
  };
}
var RsLibConfig = class {
  constructor() {
  }
  static resolve(name) {
    return __require(path.resolve(process.cwd(), name));
  }
};
function usePreEsModuleConfig(options) {
  return merge({
    output: {
      module: true,
      filename: "esm/index.js",
      chunkFormat: "module",
      library: {
        type: "module"
      }
    },
    optimization: {
      concatenateModules: true
    },
    experiments: {
      outputModule: true
    }
  }, options);
}

// src/core/run.ts
import { rspack } from "@rspack/core";
import { logger } from "node-logger-plus";
import { program } from "commander";
function rslibPackages() {
  try {
    const config = program.getOptionValue("config");
    runBuilds(RsLibConfig.resolve(config));
  } catch (err) {
    logger.error(err.message.split("\n")[0]);
  }
}
function runBuilds(libConfig, callback) {
  var _a, _b;
  const libLen = (_b = (_a = libConfig == null ? void 0 : libConfig.lib) == null ? void 0 : _a.length) != null ? _b : 0;
  if (!libLen && !libConfig.rspack) {
    logger.info(`lib length ${libLen}`, "build closed");
    return;
  }
  if (!libLen) {
    return rspack(libConfig.rspack, (err, stats) => {
      callback == null ? void 0 : callback(err, stats, -1);
      const error = err || (stats == null ? void 0 : stats.hasErrors());
      if (error) {
        logger.error(error);
      }
      logger.success("Successify!");
    });
  }
  libConfig.lib.forEach((conf, index) => {
    var _a2, _b2;
    const name = (_b2 = (_a2 = conf == null ? void 0 : conf.output) == null ? void 0 : _a2.filename) != null ? _b2 : "library";
    try {
      return rspack(conf, (err, stats) => {
        callback == null ? void 0 : callback(err, stats, index);
        const error = err || (stats == null ? void 0 : stats.hasErrors());
        if (error) {
          throw error;
        }
        logger.success(`[${name}] index: ${index} Successify!`);
      });
    } catch (err) {
      logger.error(`[${name}] index: ${index} ` + err.message.split("\n")[0]);
    }
  });
}

// src/const/config.ts
var configName = "rspack.lib.config.js";

// src/cli/index.ts
import { program as program2 } from "commander";
program2.option("c, --config <config>", "配置文件路径", configName).action(() => {
  rslibPackages();
});
function runCli() {
  program2.parse(process.argv);
}
export {
  RsLibConfig,
  RspackPluginInstance,
  configName,
  defineConfig,
  rslibPackages,
  runBuilds,
  runCli,
  usePreEsModuleConfig
};
