import { defineConfig as defineConfig$1 } from '@rspack/cli';
import { RspackPluginInstance, Stats, Compiler } from '@rspack/core';
export { RspackPluginInstance } from '@rspack/core';

type RspackOptions = Parameters<typeof defineConfig$1>[0];

interface RspackLibOptions {
    rspack: RspackOptions;
    lib?: RspackOptions[];
    plugins?: RspackPluginInstance[];
}
/**
 * 定义 rspack lib options
 * @param config
 * @returns
 */
declare function defineConfig(config: RspackLibOptions): RspackLibOptions;
declare class RsLibConfig {
    constructor();
    static resolve(name: string): any;
}
/**
 * 预设的esmodule格式
 * @param options
 * @returns
 */
declare function usePreEsModuleConfig(options: RspackOptions): RspackOptions;

declare function rslibPackages(): void;
declare function runBuilds(libConfig: RspackLibOptions, callback?: (err: Error, stats: Stats, index: number) => void): Compiler | void;

declare function runCli(): void;

declare const configName = "rspack.lib.config.js";

export { RsLibConfig, type RspackLibOptions, type RspackOptions, configName, defineConfig, rslibPackages, runBuilds, runCli, usePreEsModuleConfig };
